Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

# openvrml::field_value::counted_impl_base Class Reference

Base class for the internal reference-counted objects. More...

`#include <openvrml/field_value.h>`

Inheritance diagram for openvrml::field_value::counted_impl_base:
[legend]

List of all members.

## Public Member Functions

virtual | ~counted_impl_base () throw ()
| Destroy.
std::auto_ptr< counted_impl_base > | clone () const throw ( std::bad_alloc )
| Clone.

## Private Member Functions

virtual std::auto_ptr < counted_impl_base > | do_clone () const =0 throw ( std::bad_alloc )
| Clone.

## Detailed Description

Base class for the internal reference-counted objects.

For internal use only.

## Constructor & Destructor Documentation

openvrml::field_value::counted_impl_base::~counted_impl_base | ( |  | ) | throw ()`[virtual]`

Destroy.

## Member Function Documentation

std::auto_ptr< openvrml::field_value::counted_impl_base > openvrml::field_value::counted_impl_base::clone | ( |  | ) | const throw ( std::bad_alloc )

Clone.

Delegates to `counted_impl_base::do_clone`.

Returns:
  a clone of the instance.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

std::auto_ptr< openvrml::field_value::counted_impl_base > openvrml::field_value::counted_impl_base::do_clone | ( |  | ) | const throw ( std::bad_alloc )`[private, pure virtual]`

Clone.

Polymorphically construct a copy.

Returns:
  a clone of the instance.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

Implemented in openvrml::field_value::counted_impl< ValueType >.